using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.TransferIn.Cqrs;

public record DeleteTransferInItemCommand(string Id) : IRequest<bool>;

public class DeleteTransferInItemHandler : IRequestHandler<DeleteTransferInItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteTransferInItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteTransferInItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}